View Issue Details

IDProjectCategoryView StatusLast Update
0001645СправочникиGeneralpublic2020-11-19 15:00
Reporterruslan Assigned Tobarry  
PriorityhighSeverityfeatureReproducibilityalways
Status feedbackResolutionreopened 
PlatformКСАП ГранитOSWindows 
Summary0001645: +Справочник Организации - новый справочник Дисконтные карты
DescriptionТребуется отдельный объект для хранения информации по дисконтным картам, предполагается оборотный состав карт, т.е карта идентифицирует скидку, и может быть обменена на другую, с возвратом этой в торговую сеть и выдачей новому клиенту.
Поля нового справочника:
- Номер карты - текст(100);Для заполнения поля сделай Генератор номеров ШК в формате EAH13 начальные 2 цифры 26+Лидирующие 0+ИД карты+контр. сумма
- Прайс - лист - ссылка на пустой прайс-лист из справочника Прайс-листы
- Скидка - скидка по Прайс-листу
- Предел для выдачи следующей карты- вещественное число (10,2)
- Сумма накопленного дисконта- вещественное число (18,2)
- Клиент - ссылка на справочник Организации(для справочника Дисконтных карт - только для чтения) отображать Наименование;
Добавить кросс-таблицу для хранения связанной информации по дисконтным картам клиента:
- ИД записи
- ИД Организации
- ИД Дисконтной карты
Пока будет связь 1 к 1, но на перспективу, чтоб модель данных не переделывать
- Полное имя Клиента - ссылка на Полное наименование клиента
Вызов окна справочника Дисконтных карт добавь в Окно справочника Организаций на панель инструментов.
TagsNo tags attached.

Relationships

related to 0001646 new Склад +Склад - Доработка формы Накладной/Счета для работы с Дисконтными картами 

Activities

ruslan

2020-08-20 23:18

manager   ~0004418

Last edited: 2020-08-20 23:18

View 2 revisions

В справочнике Организации на вкладке Дополнительно - добавь поле Дисконтная карта -комбобокс для выбора - ссылка на ИД карты из справочника, отображать поле Номер карты. Связи хранить в отдельной таблице

barry

2020-11-02 21:02

administrator   ~0004422

mebl_ib5.zip
stor32.zip

ruslan

2020-11-08 20:00

manager   ~0004423

1. Активируй двойной щелчок на записи в справочнике Дисконтных карт - вход в режим редактирования записи на которой курсор.
2. Прайс - лист - ссылка на пустой прайс-лист(Без товара) из справочника Прайс-листы! Оставь в списке для выбора ТОЛЬКО прайсы без Товара.
3. Поле Скидка - закрой от изменений и отображай там поле Скидка Прайс-листа, который выбран в списке выбора Прайс-лист
4. Сумма накопленного дисконта- вещественное число (18,2) - поле доступно для редактирования только при 0.0 значении, если значение > 0 - поле закрыто для изменений
5. Поле Клиент - сейчас после сохранения 1 дисконтной карты все последующие - не сохраняет значение (остается пустым). Сделай предупреждение при наличии уже дисконтной карты у клиента "Клиент имеет дисконтную карту № ... Скидка... Сумма накоплений..." Добавить еще одну? Да/Нет кнопки.

barry

2020-11-10 08:31

administrator   ~0004424

5. Поле Клиент - сейчас после сохранения 1 дисконтной карты все последующие - не сохраняет значение (остается пустым). Сделай предупреждение при наличии уже дисконтной карты у клиента "Клиент имеет дисконтную карту № ... Скидка... Сумма накоплений..." Добавить еще одну? Да/Нет кнопки.
?
В заголовке условие "...Пока будет связь 1 к 1, но на перспективу, чтоб модель данных не переделывать". Мы же тогда отходим от правила 1 к 1. Или мы его нарушаем прямо сейчас?
Другой вопрос что не видно, что у клиента уже есть карта. Можно визуализировать например иконкой в списке организаций или еще как.
Можно выдавать предупреждение что выбрали организацию с дисконтной картой.
Можно список организаций фильтровать бескарточных...
Можно в окно редактирования организации добавить закладку дисконтных карт с динамической иконкой наличия карты,
Можно на список организаций добавить прицепленный список дисконтных карт (аналогично расчетным счетам).
.

barry

2020-11-10 08:33

administrator   ~0004425

stor32.zip
(без 5)

ruslan

2020-11-11 22:21

manager   ~0004428

>>В заголовке условие "...Пока будет связь 1 к 1, но на перспективу, чтоб модель данных не переделывать". Мы же тогда отходим от правила 1 к 1. Или мы его нарушаем прямо сейчас?
Нет.
См. мой справочник Дисконтных карт - после сохранения 1-ой записи, где я указал Организацию - все остальные сохраняются без клиента , хотя я его указываю? Этот справочник НЕ фильтруется при перемещении по справочнику Организаций как справочник Контакты например... я не понимаю это баг или фича? Как я понимаю это просто список по-умолчанию не отобранный по Организации из справочника, соответственно мы вносим туда все пространство карт на предприятии, и привязываем, какие нужно к клиентам.
Когда список карт по клиентам разрастеться, то соответственно будет тяжело визуально контролировать связь с клиентом, и чтоб пользователи не сделали несколько карт на клиента случайно я и просил сделать сообщение...

barry

2020-11-17 18:52

administrator   ~0004429

Если делать именно связанный список на организации - я думаю его в виде расчетных счетов есть смысл делать.
А сейчас справочник для всех карт подряд.
Насчет выбора организации - гляну.
Если делать фильтрованный по организации вызываемый справочник карт - думаю будет непонятно у кого вообще есть карты. Всех беспорядочно тыкать - заглядывать в окно наличия карт - это не совсем удобно. Наверное стоит иконку сделать по списку организаций - наличие карты (карт).

barry

2020-11-17 18:53

administrator   ~0004430

И общую строку поиска по номеру карты - выходим на организацию.

barry

2020-11-17 21:09

administrator   ~0004431

stor32.zip

ruslan

2020-11-17 22:42

manager   ~0004432

Вроде по требованиям все теперь Ок. Давай связанную задачу по РН заканчивать

ruslan

2020-11-17 22:48

manager   ~0004433

Ты теперь разрешил несколько дисконтов по одному клиенту... тогда добавь флаг Карта по-умолчанию, чтоб при выборе клиента в накладную автоматические эту карту выбирало и при вводе новой карты флаг Карта по-умолчанию был активен.

barry

2020-11-18 00:27

administrator   ~0004434

я не знаю как надо

ruslan

2020-11-19 15:00

manager   ~0004435

>>я не знаю как надо
Добавь флаг "Карта по-умолчанию" на форму карты под полем "Клиент". Флаг можно установить только по 1-ой карте для Организации. Флаг заполняется по-умолчанию при добавлении первой карты на панели инструментов на вкладке Карты по организации(рядом с банк.счетами)

Issue History

Date Modified Username Field Change
2020-08-20 22:49 ruslan New Issue
2020-08-20 22:56 ruslan Description Updated View Revisions
2020-08-20 23:14 ruslan Relationship added related to 0001646
2020-08-20 23:16 ruslan Description Updated View Revisions
2020-08-20 23:18 ruslan Note Added: 0004418
2020-08-20 23:18 ruslan Note Edited: 0004418 View Revisions
2020-11-02 21:02 barry Assigned To => barry
2020-11-02 21:02 barry Status new => feedback
2020-11-02 21:02 barry Note Added: 0004422
2020-11-08 20:00 ruslan Note Added: 0004423
2020-11-08 20:00 ruslan Status feedback => assigned
2020-11-08 20:00 ruslan Status assigned => feedback
2020-11-10 08:31 barry Note Added: 0004424
2020-11-10 08:33 barry Note Added: 0004425
2020-11-11 22:21 ruslan Note Added: 0004428
2020-11-11 22:21 ruslan File Added: Справочник дисконтных карт.png
2020-11-11 22:21 ruslan Status feedback => assigned
2020-11-11 22:21 ruslan Status assigned => feedback
2020-11-17 18:52 barry Note Added: 0004429
2020-11-17 18:53 barry Note Added: 0004430
2020-11-17 21:09 barry Note Added: 0004431
2020-11-17 22:42 ruslan Status feedback => resolved
2020-11-17 22:42 ruslan Resolution open => fixed
2020-11-17 22:42 ruslan Note Added: 0004432
2020-11-17 22:48 ruslan Note Added: 0004433
2020-11-18 00:27 barry Note Added: 0004434
2020-11-19 15:00 ruslan Note Added: 0004435
2020-11-19 15:00 ruslan Status resolved => feedback
2020-11-19 15:00 ruslan Resolution fixed => reopened